/*-----------------------------------------------------------------------------
 * Copyright (C) 2007, Onstor Inc.
 *
 * Name         : openbsd.h
 *
 * Description  : System dependent definitions for ssc-nfxsh module.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef _SSC_NFXSH_OPENBSD_H
#define _SSC_NFXSH_OPENBSD_H

#define PATHNAME_NTPQ		"/usr/local/bin/ntpq"
#define PATHNAME_SED		"/usr/bin/sed"
#define PATHNAME_GREP		"/usr/bin/grep"
#define FILEXFERCMD			"/usr/bin/ftp"

/* Source bind IP address option */
#define FILEXFERSRCOPT  "-s "

/* Remote input filename option */
#define FILEXFERFRMOPT  "-m "

/* Local output filename option */
#define FILEXFERTOOPT   "-o "

/* Mount command for memory file system, size in 512 byte blocks */
#define MOUNT_RAMFS "/sbin/mount_mfs -m 0 -s 120000 swap"

/*
 * OS specific file names
 */
#define DEF_ROUTE_FILE	"/etc/mygate"			/* default route file */
#define HOSTNAME_FILE	"/etc/myname"			/* hostname */
#define DTEXT			"label"				/* dtab_name file extension */

/*
 * OS specific partition size percentages
 */
#define VAR_SZ_PERCENT			.16
#define ONSTOR_CONF_SZ_PERCENT	.10

/*
 * OS specific filesystem tweaking tasks
 * Nothing yet on OpenBSD
 */
#define OS_CF_TWEAKAGE do {} while (0)

/*
 * OS specific code to reset management interface configuration
 */
#define UNHINGE_IFACES \
	ret_val = unlink("/etc/hostname.sc1");								\
	if (ret_val < 0) {													\
		err_val = errno;												\
		if (!(err_val == ENOENT)) {										\
			sprintf(log_buf, "removing /etc/hostname.sc1 file"			\
					" failed : %s", strerror(errno));					\
			do_log(LOG_INFO, log_buf);									\
		}																\
	}																	\
																		\
	ret_val = unlink("/etc/hostname.sc2");								\
	if (ret_val < 0) {													\
		err_val = errno;												\
		if (!(err_val == ENOENT)) {										\
			sprintf(log_buf, "removing /etc/hostname.sc2 file"			\
					" failed : %s", strerror(errno));					\
			do_log(LOG_INFO, log_buf);									\
		}																\
	}

#define RESET_DEF_ROUTE(file) unlink(file)

#define RESET_PASSWORD_FILE \
			ret_val = copyFile("/etc/master.passwd.org", "/etc/master.passwd");\
			if (ret_val < 0) {												\
				sprintf(log_buf,											\
					"restoring default master passwd file failed : %s",		\
					strerror(errno));										\
				do_log(LOG_INFO, log_buf);									\
			}																\
																			\
			ret_val = chmod("/etc/master.passwd", 0600);					\
			if (ret_val < 0) {												\
				sprintf(log_buf,											\
						"changing master.passwd to 600 mode failed : %s",	\
						strerror(errno));									\
				do_log(LOG_INFO, log_buf);									\
			}

#define CLEAN_VAR \
	while (0) {}

#endif	/* _SSC_NFXSH_OPENBSD_H */
